Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 1364)
+++ /palm/trunk/SOURCE/Makefile	(revision 1365)
@@ -20,5 +20,6 @@
 # Current revisions:
 # ------------------
-# 
+# Added new module calc_mean_profile, previously in module buoyancy,
+# removed buoyancy dependency from nudging
 # 
 # Former revisions:
@@ -162,9 +163,10 @@
 	advec_u_pw.f90 advec_u_up.f90 advec_v_pw.f90 advec_v_up.f90 \
 	advec_w_pw.f90 advec_w_up.f90 average_3d_data.f90 boundary_conds.f90 \
-	buoyancy.f90 calc_liquid_water_content.f90 calc_precipitation.f90 \
-	calc_radiation.f90 calc_spectra.f90 check_for_restart.f90 \
-	check_open.f90 check_parameters.f90 close_file.f90 compute_vpt.f90 \
-	coriolis.f90 cpulog.f90 cuda_fft_interfaces.f90 data_log.f90 \
-	data_output_dvrp.f90 data_output_mask.f90 data_output_profiles.f90 \
+	buoyancy.f90 calc_liquid_water_content.f90 calc_mean_profile.f90 \
+	calc_precipitation.f90 calc_radiation.f90 calc_spectra.f90 \
+	check_for_restart.f90 check_open.f90 check_parameters.f90 \
+	close_file.f90 compute_vpt.f90 coriolis.f90 cpulog.f90 \
+	cuda_fft_interfaces.f90 data_log.f90 data_output_dvrp.f90 \
+	data_output_mask.f90 data_output_profiles.f90 \
 	data_output_ptseries.f90 data_output_spectra.f90 \
 	data_output_tseries.f90 data_output_2d.f90 data_output_3d.f90 \
@@ -256,4 +258,5 @@
 boundary_conds.o: modules.o mod_kinds.o
 buoyancy.o: modules.o mod_kinds.o
+calc_mean_profile.o: modules.o mod_kinds.o
 calc_liquid_water_content.o: modules.o mod_kinds.o
 calc_precipitation.o: modules.o mod_kinds.o
@@ -352,5 +355,5 @@
 mod_particle_attributes.o: mod_particle_attributes.f90 mod_kinds.o
 netcdf.o: modules.o mod_kinds.o
-nudging.o: modules.o buoyancy.o cpulog.o mod_kinds.o
+nudging.o: modules.o cpulog.o mod_kinds.o
 package_parin.o: modules.o mod_kinds.o
 palm.o: modules.o cpulog.o ls_forcing.o mod_kinds.o nudging.o
@@ -382,6 +385,7 @@
 swap_timelevel.o: modules.o cpulog.o mod_kinds.o
 temperton_fft.o: modules.o mod_kinds.o
-time_integration.o: modules.o advec_ws.o buoyancy.o cpulog.o interaction_droplets_ptq.o \
-	ls_forcing.o mod_kinds.o production_e.o prognostic_equations.o user_actions.o
+time_integration.o: modules.o advec_ws.o buoyancy.o calc_mean_profile.o \
+	cpulog.o interaction_droplets_ptq.o ls_forcing.o mod_kinds.o \
+	production_e.o prognostic_equations.o user_actions.o
 time_to_string.o: mod_kinds.o
 timestep.o: modules.o cpulog.o mod_kinds.o
Index: /palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- /palm/trunk/SOURCE/buoyancy.f90	(revision 1364)
+++ /palm/trunk/SOURCE/buoyancy.f90	(revision 1365)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! Calculation of reference state in subroutine calc_mean_profile moved to
+! subroutine time_integration,
+! subroutine calc_mean_profile moved to new file calc_mean_profile.f90
 ! 
 ! Former revisions:
@@ -78,5 +80,5 @@
 
     PRIVATE
-    PUBLIC buoyancy, buoyancy_acc, calc_mean_profile
+    PUBLIC buoyancy, buoyancy_acc
 
     INTERFACE buoyancy
@@ -88,8 +90,4 @@
        MODULE PROCEDURE buoyancy_acc
     END INTERFACE buoyancy_acc
-
-    INTERFACE calc_mean_profile
-       MODULE PROCEDURE calc_mean_profile
-    END INTERFACE calc_mean_profile
 
  CONTAINS
@@ -376,114 +374,3 @@
     END SUBROUTINE buoyancy_ij
 
-
-    SUBROUTINE calc_mean_profile( var, pr, loc )
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-! Calculate the horizontally averaged vertical temperature profile (pr=4 in case
-! of potential temperature, 44 in case of virtual potential temperature, and 64
-! in case of density (ocean runs)).
-!------------------------------------------------------------------------------!
-
-       USE arrays_3d,                                                          &
-           ONLY:  ref_state
-
-       USE control_parameters,                                                 &
-           ONLY:  intermediate_timestep_count, message_string
-
-       USE indices,                                                            &
-           ONLY:  ngp_2dh_s_inner, nxl, nxr, nyn, nys, nzb, nzb_s_inner, nzt
-
-       USE kinds
-
-       USE pegrid
-
-       USE statistics,                                                         &
-           ONLY:  flow_statistics_called, hom, sums, sums_l
-
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  loc !:
-       
-       INTEGER(iwp) ::  i                  !:
-       INTEGER(iwp) ::  j                  !:
-       INTEGER(iwp) ::  k                  !:
-       INTEGER(iwp) ::  pr                 !: 
-       INTEGER(iwp) ::  omp_get_thread_num !:
-       INTEGER(iwp) ::  tn                 !:
-       
-#if defined( __nopointer )
-       REAL(wp), DIMENSION(:,:,:) ::  var  !:
-#else
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  var
-#endif
-
-!
-!--    Computation of the horizontally averaged profile of variable var, unless
-!--    already done by the relevant call from flow_statistics. The calculation
-!--    is done only for the first respective intermediate timestep in order to
-!--    spare communication time and to produce identical model results with jobs
-!--    which are calling flow_statistics at different time intervals.
-       IF ( .NOT. flow_statistics_called  .AND.                                &
-            intermediate_timestep_count == 1 )  THEN
-
-!
-!--       Horizontal average of variable var
-          tn           =   0  ! Default thread number in case of one thread
-          !$OMP PARALLEL PRIVATE( i, j, k, tn )
-!$        tn = omp_get_thread_num()
-          sums_l(:,pr,tn) = 0.0_wp
-          !$OMP DO
-          DO  i = nxl, nxr
-             DO  j =  nys, nyn
-                DO  k = nzb_s_inner(j,i), nzt+1
-                   sums_l(k,pr,tn) = sums_l(k,pr,tn) + var(k,j,i)
-                ENDDO
-             ENDDO
-          ENDDO
-          !$OMP END PARALLEL
-
-          DO  i = 1, threads_per_task-1
-             sums_l(:,pr,0) = sums_l(:,pr,0) + sums_l(:,pr,i)
-          ENDDO
-
-#if defined( __parallel )
-
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,pr,0), sums(nzb,pr), nzt+2-nzb,       &
-                              MPI_REAL, MPI_SUM, comm2d, ierr )
-
-#else
-
-          sums(:,pr) = sums_l(:,pr,0)
-
-#endif
-
-          hom(:,1,pr,0) = sums(:,pr) / ngp_2dh_s_inner(:,0)
-
-       ENDIF
-
-       SELECT CASE ( loc )
-
-          CASE ( 'time_int' )
-
-             ref_state(:)  = hom(:,1,pr,0)   ! this is used in the buoyancy term
-
-
-          CASE ( 'nudging' )
-             !nothing to be done
-
-
-          CASE DEFAULT
-             message_string = 'unknown location "' // loc // '"'
-             CALL message( 'calc_mean_profile', 'PA0379', 1, 2, 0, 6, 0 )
-
-       END SELECT
-
-
-
-    END SUBROUTINE calc_mean_profile
-
  END MODULE buoyancy_mod
Index: /palm/trunk/SOURCE/calc_mean_profile.f90
===================================================================
--- /palm/trunk/SOURCE/calc_mean_profile.f90	(revision 1365)
+++ /palm/trunk/SOURCE/calc_mean_profile.f90	(revision 1365)
@@ -0,0 +1,123 @@
+ MODULE calc_mean_profile_mod
+
+!--------------------------------------------------------------------------------!
+! This file is part of PALM.
+!
+! PALM is free software: you can redistribute it and/or modify it under the terms
+! of the GNU General Public License as published by the Free Software Foundation,
+! either version 3 of the License, or (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2014 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! Description:
+! ------------
+! Calculate the horizontally averaged vertical temperature profile (pr=4 in case
+! of potential temperature, 44 in case of virtual potential temperature, and 64
+! in case of density (ocean runs)).
+!------------------------------------------------------------------------------!
+
+    PRIVATE
+    PUBLIC calc_mean_profile
+
+    INTERFACE calc_mean_profile
+       MODULE PROCEDURE calc_mean_profile
+    END INTERFACE calc_mean_profile
+
+ CONTAINS
+
+    SUBROUTINE calc_mean_profile( var, pr )
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, message_string
+
+       USE indices,                                                            &
+           ONLY:  ngp_2dh_s_inner, nxl, nxr, nyn, nys, nzb, nzb_s_inner, nzt
+
+       USE kinds
+
+       USE pegrid
+
+       USE statistics,                                                         &
+           ONLY:  flow_statistics_called, hom, sums, sums_l
+
+
+       IMPLICIT NONE
+       
+       INTEGER(iwp) ::  i                  !:
+       INTEGER(iwp) ::  j                  !:
+       INTEGER(iwp) ::  k                  !:
+       INTEGER(iwp) ::  pr                 !: 
+       INTEGER(iwp) ::  omp_get_thread_num !:
+       INTEGER(iwp) ::  tn                 !:
+       
+#if defined( __nopointer )
+       REAL(wp), DIMENSION(:,:,:) ::  var  !:
+#else
+       REAL(wp), DIMENSION(:,:,:), POINTER ::  var
+#endif
+
+!
+!--    Computation of the horizontally averaged profile of variable var, unless
+!--    already done by the relevant call from flow_statistics. The calculation
+!--    is done only for the first respective intermediate timestep in order to
+!--    spare communication time and to produce identical model results with jobs
+!--    which are calling flow_statistics at different time intervals.
+       IF ( .NOT. flow_statistics_called  .AND.                                &
+            intermediate_timestep_count == 1 )  THEN
+
+!
+!--       Horizontal average of variable var
+          tn           =   0  ! Default thread number in case of one thread
+          !$OMP PARALLEL PRIVATE( i, j, k, tn )
+!$        tn = omp_get_thread_num()
+          sums_l(:,pr,tn) = 0.0_wp
+          !$OMP DO
+          DO  i = nxl, nxr
+             DO  j =  nys, nyn
+                DO  k = nzb_s_inner(j,i), nzt+1
+                   sums_l(k,pr,tn) = sums_l(k,pr,tn) + var(k,j,i)
+                ENDDO
+             ENDDO
+          ENDDO
+          !$OMP END PARALLEL
+
+          DO  i = 1, threads_per_task-1
+             sums_l(:,pr,0) = sums_l(:,pr,0) + sums_l(:,pr,i)
+          ENDDO
+
+#if defined( __parallel )
+
+          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_ALLREDUCE( sums_l(nzb,pr,0), sums(nzb,pr), nzt+2-nzb,       &
+                              MPI_REAL, MPI_SUM, comm2d, ierr )
+
+#else
+
+          sums(:,pr) = sums_l(:,pr,0)
+
+#endif
+
+          hom(:,1,pr,0) = sums(:,pr) / ngp_2dh_s_inner(:,0)
+
+       ENDIF
+
+
+    END SUBROUTINE calc_mean_profile
+
+ END MODULE calc_mean_profile_mod
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1364)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1365)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-! 
+! Usage of large scale forcing for pt and q enabled:
+! output for profiles of large scale advection (td_lsa_lpt, td_lsa_q), 
+! large scale subsidence (td_sub_lpt, td_sub_q) 
+! and nudging tendencies (td_nud_lpt, td_nud_q, td_nud_u and td_nud_v) added,
+! check if use_subsidence_tendencies is used correctly
 ! 
 ! Former revisions:
@@ -1271,4 +1275,16 @@
        ENDIF
          
+    ENDIF
+
+!
+!-- Check if the control parameter use_subsidence_tendencies is used correctly
+    IF ( use_subsidence_tendencies  .AND.  .NOT. large_scale_subsidence )  THEN
+       message_string = 'The usage of use_subsidence_tendencies ' // &
+                            'requires large_scale_subsidence = .T..'
+       CALL message( 'check_parameters', 'PA0396', 1, 2, 0, 6, 0 )
+    ELSEIF ( use_subsidence_tendencies  .AND.  .NOT. large_scale_forcing )  THEN
+       message_string = 'The usage of use_subsidence_tendencies ' // &
+                            'requires large_scale_forcing = .T..'
+       CALL message( 'check_parameters', 'PA0397', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2661,4 +2677,101 @@
              ENDIF
 
+          CASE ( 'td_lsa_lpt' )
+             IF ( .NOT. large_scale_forcing )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for large_scale_forcing = .FALSE.'
+                CALL message( 'check_parameters', 'PA0393', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 81
+                dopr_unit(i)  = 'K/s'
+                hom(:,2,81,:) = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'td_lsa_q' )
+             IF ( .NOT. large_scale_forcing )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for large_scale_forcing = .FALSE.'
+                CALL message( 'check_parameters', 'PA0393', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 82
+                dopr_unit(i)  = 'kg/kgs'
+                hom(:,2,82,:) = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'td_sub_lpt' )
+             IF ( .NOT. large_scale_forcing )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for large_scale_forcing = .FALSE.'
+                CALL message( 'check_parameters', 'PA0393', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 83
+                dopr_unit(i)  = 'K/s'
+                hom(:,2,83,:) = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'td_sub_q' )
+             IF ( .NOT. large_scale_forcing )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for large_scale_forcing = .FALSE.'
+                CALL message( 'check_parameters', 'PA0393', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 84
+                dopr_unit(i)  = 'kg/kgs'
+                hom(:,2,84,:) = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'td_nud_lpt' )
+             IF ( .NOT. nudging )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for nudging = .FALSE.'
+                CALL message( 'check_parameters', 'PA0394', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 85
+                dopr_unit(i)  = 'K/s'
+                hom(:,2,85,:) = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'td_nud_q' )
+             IF ( .NOT. nudging )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for nudging = .FALSE.'
+                CALL message( 'check_parameters', 'PA0394', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 86
+                dopr_unit(i)  = 'kg/kgs'
+                hom(:,2,86,:) = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'td_nud_u' )
+             IF ( .NOT. nudging )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for nudging = .FALSE.'
+                CALL message( 'check_parameters', 'PA0394', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 87
+                dopr_unit(i)  = 'm/s2'
+                hom(:,2,87,:) = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'td_nud_v' )
+             IF ( .NOT. nudging )  THEN
+                message_string = 'data_output_pr = ' // &
+                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
+                                 'lemented for nudging = .FALSE.'
+                CALL message( 'check_parameters', 'PA0394', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 88
+                dopr_unit(i)  = 'm/s2'
+                hom(:,2,88,:) = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+
           CASE DEFAULT
 
Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 1364)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 1365)
@@ -21,5 +21,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Output of large scale advection, large scale subsidence and nudging tendencies
+! +sums_ls_l, ngp_sums_ls, use_subsidence_tendencies
 ! 
 ! Former revisions:
@@ -95,7 +96,8 @@
 
     USE arrays_3d,                                                             &
-        ONLY :  ddzu, ddzw, e, hyp, km, kh,nr,  p, prho, pt, q, qc, ql, qr,    &
-                qs, qsws, qswst, rho, sa, saswsb, saswst, shf, ts, tswst, u,   &
-                ug, us, usws, uswst, vsws, v, vg, vpt, vswst, w, w_subs, zw
+        ONLY:  ddzu, ddzw, e, hyp, km, kh, nr, p, prho, pt, pt_lsa, pt_subs, q,&
+               qc, ql, qr, qs, qsws, qswst, q_lsa, q_subs, rho, sa, saswsb,    &
+               saswst, shf, time_vert, ts, tswst, u, ug, us, usws, uswst, vsws,&
+               v, vg, vpt, vswst, w, w_subs, zw
         
     USE cloud_parameters,                                                      &
@@ -104,7 +106,9 @@
     USE control_parameters,                                                    &
         ONLY :  average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
-                dt_3d, g, humidity, icloud_scheme, kappa, max_pr_user,         &
-                message_string, ocean, passive_scalar, precipitation,          &
-                use_surface_fluxes, use_top_fluxes, ws_scheme_mom, ws_scheme_sca
+                dt_3d, g, humidity, icloud_scheme, kappa, large_scale_forcing, &
+                large_scale_subsidence, max_pr_user, message_string, ocean,    &
+                passive_scalar, precipitation, simulated_time,                 &
+                use_subsidence_tendencies, use_surface_fluxes, use_top_fluxes, &
+                ws_scheme_mom, ws_scheme_sca
         
     USE cpulog,                                                                &
@@ -115,6 +119,7 @@
         
     USE indices,                                                               &
-        ONLY :  ngp_2dh, ngp_2dh_s_inner, ngp_3d, ngp_3d_inner, ngp_sums, nxl, &
-                nxr, nyn, nys, nzb, nzb_diff_s_inner, nzb_s_inner, nzt, nzt_diff
+        ONLY :  ngp_2dh, ngp_2dh_s_inner, ngp_3d, ngp_3d_inner, ngp_sums,      &
+                ngp_sums_ls, nxl, nxr, nyn, nys, nzb, nzb_diff_s_inner,        &
+                nzb_s_inner, nzt, nzt_diff
         
     USE kinds
@@ -129,4 +134,5 @@
     INTEGER(iwp) ::  j                   !:
     INTEGER(iwp) ::  k                   !:
+    INTEGER(iwp) ::  nt                  !:
     INTEGER(iwp) ::  omp_get_thread_num  !:
     INTEGER(iwp) ::  sr                  !:
@@ -136,4 +142,5 @@
     
     REAL(wp) ::  dptdz_threshold  !: 
+    REAL(wp) ::  fac              !:
     REAL(wp) ::  height           !:
     REAL(wp) ::  pts              !:
@@ -982,4 +989,42 @@
 
 !
+!--    Collect current large scale advection and subsidence tendencies for
+!--    data output
+       IF ( large_scale_forcing )  THEN
+!
+!--       Interpolation in time of LSF_DATA 
+          nt = 1
+          DO WHILE ( simulated_time > time_vert(nt) )
+             nt = nt + 1
+          ENDDO
+          IF ( simulated_time /= time_vert(nt) )  THEN
+            nt = nt - 1
+          ENDIF
+
+          fac = ( simulated_time-time_vert(nt) )                               &
+                / ( time_vert(nt+1)-time_vert(nt) )
+
+
+          DO  k = nzb, nzt
+             sums_ls_l(k,0) = pt_lsa(k,nt)                                     &
+                              + fac * ( pt_lsa(k,nt+1) - pt_lsa(k,nt) )
+             sums_ls_l(k,1) = q_lsa(k,nt)                                      &
+                              + fac * ( q_lsa(k,nt+1) - q_lsa(k,nt) )
+          ENDDO
+
+          IF ( large_scale_subsidence .AND. use_subsidence_tendencies )  THEN
+
+             DO  k = nzb, nzt
+                sums_ls_l(k,2) = pt_subs(k,nt)                                 &
+                                 + fac * ( pt_subs(k,nt+1) - pt_subs(k,nt) )
+                sums_ls_l(k,3) = q_subs(k,nt)                                  &
+                                 + fac * ( q_subs(k,nt+1) - q_subs(k,nt) )
+             ENDDO
+
+          ENDIF
+
+       ENDIF
+
+!
 !--    Calculate the user-defined profiles
        CALL user_statistics( 'profiles', sr, tn )
@@ -1007,8 +1052,15 @@
 !--    Compute total sum from local sums
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), ngp_sums, MPI_REAL, &
+       CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), ngp_sums, MPI_REAL,   &
                            MPI_SUM, comm2d, ierr )
+       IF ( large_scale_forcing )  THEN
+          CALL MPI_ALLREDUCE( sums_ls_l(nzb,2), sums(nzb,83), ngp_sums_ls,     &
+                              MPI_REAL, MPI_SUM, comm2d, ierr )
+       ENDIF
 #else
        sums = sums_l(:,:,0)
+       IF ( large_scale_forcing )  THEN
+          sums(:,81:88) = sums_ls_l
+       ENDIF
 #endif
 
@@ -1031,5 +1083,7 @@
           sums(k,64)              = sums(k,64)          / ngp_2dh_s_inner(k,sr)
           sums(k,65:69)           = sums(k,65:69)       / ngp_2dh(sr)
-          sums(k,70:pr_palm-2)    = sums(k,70:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
+          sums(k,70:80)           = sums(k,70:80)       / ngp_2dh_s_inner(k,sr)
+          sums(k,81:88)           = sums(k,81:88)       / ngp_2dh(sr)
+          sums(k,89:pr_palm-2)    = sums(k,89:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
        ENDDO
 
@@ -1130,4 +1184,20 @@
        hom(:,1,80,sr) = w_subs         ! w_subs
 
+       IF ( large_scale_forcing )  THEN
+          hom(:,1,81,sr) = sums_ls_l(:,0)          ! pt_lsa
+          hom(:,1,82,sr) = sums_ls_l(:,1)          ! q_lsa
+          IF ( use_subsidence_tendencies )  THEN
+             hom(:,1,83,sr) = sums_ls_l(:,2)       ! pt_subs
+             hom(:,1,84,sr) = sums_ls_l(:,3)       ! q_subs
+          ELSE
+             hom(:,1,83,sr) = sums(:,83)           ! pt_subs
+             hom(:,1,84,sr) = sums(:,84)           ! q_subs
+          ENDIF
+          hom(:,1,85,sr) = sums(:,85)              ! pt_nudge
+          hom(:,1,86,sr) = sums(:,86)              ! q_nudge
+          hom(:,1,87,sr) = sums(:,87)              ! u_nudge
+          hom(:,1,88,sr) = sums(:,88)              ! v_nudge
+       ENDIF
+
        hom(:,1,pr_palm-1,sr) = sums(:,pr_palm-1)
                                        ! upstream-parts u_x, u_y, u_z, v_x,
@@ -1309,7 +1379,9 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  ddzu, ddzw, e, hyp, km, kh,nr,  p, prho, pt, q, qc, ql, qr,     &
-               qs, qsws, qswst, rho, sa, saswsb, saswst, shf, ts, tswst, u,    &
-               ug, us, usws, uswst, vsws, v, vg, vpt, vswst, w, w_subs, zw
+        ONLY:  ddzu, ddzw, e, hyp, km, kh, nr, p, prho, pt, pt_lsa, pt_subs, q,&
+               qc, ql, qr, qs, qsws, qswst, q_lsa, q_subs, rho, sa, saswsb,    &
+               saswst, shf, time_vert, ts, tswst, u, ug, us, usws, uswst, vsws,&
+               v, vg, vpt, vswst, w, w_subs, zw
+                 
         
     USE cloud_parameters,                                                      &
@@ -1317,8 +1389,10 @@
         
     USE control_parameters,                                                    &
-        ONLY:  average_count_pr, cloud_droplets, cloud_physics, do_sum,        &
-               dt_3d, g, humidity, icloud_scheme, kappa, max_pr_user,          &
-               message_string, ocean, passive_scalar, precipitation,           &
-               use_surface_fluxes, use_top_fluxes, ws_scheme_mom, ws_scheme_sca
+        ONLY :  average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
+                dt_3d, g, humidity, icloud_scheme, kappa, large_scale_forcing, &
+                large_scale_subsidence, max_pr_user, message_string, ocean,    &
+                passive_scalar, precipitation, simulated_time,                 &
+                use_subsidence_tendencies, use_surface_fluxes, use_top_fluxes, &
+                ws_scheme_mom, ws_scheme_sca
         
     USE cpulog,                                                                &
@@ -1343,4 +1417,5 @@
     INTEGER(iwp) ::  j                   !:
     INTEGER(iwp) ::  k                   !:
+    INTEGER(iwp) ::  nt                  !:
     INTEGER(iwp) ::  omp_get_thread_num  !:
     INTEGER(iwp) ::  sr                  !:
@@ -1350,4 +1425,5 @@
     
     REAL(wp) ::  dptdz_threshold  !:
+    REAL(wp) ::  fac              !:
     REAL(wp) ::  height           !:
     REAL(wp) ::  pts              !:
@@ -2661,4 +2737,42 @@
 
 !
+!--    Collect current large scale advection and subsidence tendencies for
+!--    data output
+       IF ( large_scale_forcing )  THEN
+!
+!--       Interpolation in time of LSF_DATA 
+          nt = 1
+          DO WHILE ( simulated_time > time_vert(nt) )
+             nt = nt + 1
+          ENDDO
+          IF ( simulated_time /= time_vert(nt) )  THEN
+            nt = nt - 1
+          ENDIF
+
+          fac = ( simulated_time-time_vert(nt) )                               &
+                / ( time_vert(nt+1)-time_vert(nt) )
+
+
+          DO  k = nzb, nzt
+             sums_ls_l(k,0) = pt_lsa(k,nt)                                     &
+                              + fac * ( pt_lsa(k,nt+1) - pt_lsa(k,nt) )
+             sums_ls_l(k,1) = q_lsa(k,nt)                                      &
+                              + fac * ( q_lsa(k,nt+1) - q_lsa(k,nt) )
+          ENDDO
+
+          IF ( large_scale_subsidence .AND. use_subsidence_tendencies )  THEN
+
+             DO  k = nzb, nzt
+                sums_ls_l(k,2) = pt_subs(k,nt)                                 &
+                                 + fac * ( pt_subs(k,nt+1) - pt_subs(k,nt) )
+                sums_ls_l(k,3) = q_subs(k,nt)                                  &
+                                 + fac * ( q_subs(k,nt+1) - q_subs(k,nt) )
+             ENDDO
+
+          ENDIF
+
+       ENDIF
+
+!
 !--    Calculate the user-defined profiles
        CALL user_statistics( 'profiles', sr, tn )
@@ -2691,6 +2805,13 @@
        CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), ngp_sums, MPI_REAL, &
                            MPI_SUM, comm2d, ierr )
+       IF ( large_scale_forcing )  THEN
+          CALL MPI_ALLREDUCE( sums_ls_l(nzb,2), sums(nzb,83), ngp_sums_ls,     &
+                              MPI_REAL, MPI_SUM, comm2d, ierr )
+       ENDIF
 #else
        sums = sums_l(:,:,0)
+       IF ( large_scale_forcing )  THEN
+          sums(:,81:88) = sums_ls_l
+       ENDIF
 #endif
 
@@ -2712,6 +2833,7 @@
           sums(k,55:63)           = sums(k,55:63)       / ngp_2dh(sr)
           sums(k,64)              = sums(k,64)          / ngp_2dh_s_inner(k,sr)
-          sums(k,65:69)           = sums(k,65:69)       / ngp_2dh(sr)
-          sums(k,70:pr_palm-2)    = sums(k,70:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
+          sums(k,70:80)           = sums(k,70:80)       / ngp_2dh_s_inner(k,sr)
+          sums(k,81:88)           = sums(k,81:88)       / ngp_2dh(sr)
+          sums(k,89:pr_palm-2)    = sums(k,89:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
        ENDDO
 
@@ -2812,4 +2934,20 @@
        hom(:,1,80,sr) = w_subs         ! w_subs
 
+       IF ( large_scale_forcing )  THEN
+          hom(:,1,81,sr) = sums_ls_l(:,0)          ! pt_lsa
+          hom(:,1,82,sr) = sums_ls_l(:,1)          ! q_lsa
+          IF ( use_subsidence_tendencies )  THEN
+             hom(:,1,83,sr) = sums_ls_l(:,2)       ! pt_subs
+             hom(:,1,84,sr) = sums_ls_l(:,3)       ! q_subs
+          ELSE
+             hom(:,1,83,sr) = sums(:,83)           ! pt_subs
+             hom(:,1,84,sr) = sums(:,84)           ! q_subs
+          ENDIF
+          hom(:,1,85,sr) = sums(:,85)              ! pt_nudge
+          hom(:,1,86,sr) = sums(:,86)              ! q_nudge
+          hom(:,1,87,sr) = sums(:,87)              ! u_nudge
+          hom(:,1,88,sr) = sums(:,88)              ! v_nudge
+       END IF
+
        hom(:,1,pr_palm-1,sr) = sums(:,pr_palm-1)
                                        ! upstream-parts u_x, u_y, u_z, v_x,
